PROGRAM SEDM1 (txt1,txt2);
USES CRT;
CONST
      filen1 = 'msf.dat';
      filen2 = 'mtsf.dat';

VAR i,a,selection,c,sel,
    portadres,cutfeed,feedpause,
    retractstep,rtrstp1,stpcnt,
    rtrstp,stepcount,cnt,maxspeed,
    fb,hs1,hs2,x,z:INTEGER;

    pitch,angle,motorstep,resolution,
    cutdepth,depth,depth1:REAL;

    d,e,f,ch,ans,unt1:CHAR;

    unt:STRING;

    txt1,txt2:TEXT;

PROCEDURE writeline;
BEGIN
  writeln;
  writeln;
  writeln;
END;

PROCEDURE enter_program(a:INTEGER);
BEGIN
  clrscr;
  delay (750);
  writeline;
  writeln ('______________________________':54);
  writeln ('S-EDM for the Home Shop':50);
  writeln ('______________________________':54);
  writeln;
  delay (2000);
  writeln ('TestWare':42);
  writeln;
  delay (1000);
  writeln ('Version 1.0':44);
  writeline;
  delay (1000);
  writeln ('Copyright 2000 Proved By Practice Publications':63);
  writeline;
  delay (500);
  writeln ('Press Enter to continue':50);
  readln;
  clrscr;
  a := 0;
  REPEAT
  BEGIN
    clrscr;
    delay (500);
    writeline;
    writeln ('!WARNING!':40);
    delay (500);
    a := a + 1;
  END;
  UNTIL a > 3;
  writeline;
  writeln ('Make sure EDM circuit is turned "off"':57);
  writeline;
  delay (2500);
  writeln ('Press Enter to continue':48);
  readln;
  clrscr;
END;

PROCEDURE write_file1;
BEGIN
  assign (txt1, filen1);
  rewrite(txt1);
  writeln(txt1,portadres);
  writeln(txt1,unt);
  writeln(txt1,pitch);
  writeln(txt1,angle);
  writeln(txt1,maxspeed);
  close(txt1);
END;

PROCEDURE machine_setup (d:CHAR; VAR portadres:INTEGER; VAR pitch,angle:REAL; VAR maxspeed:INTEGER);
BEGIN
  readln;
  clrscr;
  REPEAT
    BEGIN
    writeln;
    writeln ('Machine Setup');
    writeln;
    delay(500);
    REPEAT
      write('Enter port address (278 or 378)             :   ');
      readln(portadres);
    UNTIL (portadres = 278) OR (portadres = 378);
      IF portadres = 278 THEN
      portadres := 632;
      IF portadres = 378 THEN
      portadres := 888;
    REPEAT
      write('Enter unit used mm or Inches (m or i)       :   ');
      readln(unt1);
    UNTIL (unt1 = 'm') OR (unt1 = 'i') OR (unt1 = 'M') OR (unt1 = 'I');
      IF (unt1 = 'm') OR (unt1 = 'M') THEN
      unt := 'mm';
      IF (unt1 = 'i') OR (unt1 = 'I') THEN
      unt := 'Inches';
    REPEAT
      write ('Enter lead screw pitch                      :   ');
      readln(pitch);
    UNTIL (pitch > 0) AND (pitch < 3);
    REPEAT
      write ('Enter step angle of motor                   :   ');
      readln(angle);
    UNTIL (angle > 0) AND (angle < 50);
    REPEAT
      write ('Enter maximum feed speed (steps per second) :   ');
      readln(maxspeed);
    UNTIL (maxspeed > 0) AND (maxspeed < 5000);
    maxspeed := round(1000 / maxspeed);
    writeln;
    writeln ('Save values and exit "Machine Setup"?: (y or n)');
    read (d);
    END
UNTIL (d = 'y') OR (d = 'Y');
write_file1;
END;

PROCEDURE write_file2;
BEGIN
  assign (txt2, filen2);
  rewrite(txt2);
  writeln(txt2,cutfeed);
  writeln(txt2,feedpause);
  writeln(txt2,retractstep);
  writeln(txt2,cutdepth);
  close(txt2);
END;


PROCEDURE machine_task_setup(e:char; var cutfeed,feedpause,retractstep:integer; var cutdepth:real);
BEGIN
  readln;
  clrscr;
  REPEAT
  BEGIN
    writeln;
    writeln('Machine Task Setup');
    writeln;
    delay(500);
    REPEAT
      write ('Enter cutting feed speed (steps per second):  ');
      readln(cutfeed);
    UNTIL (cutfeed > 0) AND (cutfeed < 5000);
    cutfeed:= round(1000/cutfeed);
    REPEAT
      write ('Enter feed pause time (seconds)            :  ');
      readln(feedpause);
    UNTIL (feedpause > 0) AND (feedpause < 500);
      feedpause := 1000 * feedpause;
    REPEAT
      write ('Enter amount of retract steps              :  ');
      readln(retractstep);
    UNTIL (retractstep > 0) AND (retractstep < 5000);
    REPEAT
      write ('Enter cut depth                            :  ');
      readln(cutdepth);
    UNTIL (cutdepth > 0) AND (cutdepth < 35);
      writeln;
      writeln ('Save values and exit "Machine Task Setup"? (y or n):');
      read (e);
    END;
UNTIL (e = 'y') OR (e = 'Y');
write_file2;
END;

PROCEDURE read_file12;
BEGIN
  clrscr;
  writeln;
  writeln('Accessing file data, please wait');
  assign (txt1,filen1);
  reset(txt1);
  readln(txt1,portadres);
  readln(txt1,unt);
  readln(txt1,pitch);
  readln(txt1,angle);
  readln(txt1,maxspeed);
  close(txt1);
  assign (txt2, filen2);
  reset(txt2);
  readln(txt2,cutfeed);
  readln(txt2,feedpause);
  readln(txt2,retractstep);
  readln(txt2,cutdepth);
  close(txt2);
  delay(500);
  writeln('Press Enter');
  readln;
END;

PROCEDURE which_switch;
BEGIN
  clrscr;
  writeln;
  writeln('---------------------------------------':58);
  writeln('Switching detected at input pin ':53,z);
  delay(200);
  writeln;
  writeln('This switch must represent Home Switch ':58,x);
  writeln('---------------------------------------':58);
  writeln;
  writeln;
  writeln;
  writeln;
  writeln;
  delay(500);
  writeln('Test another switch or press any key to abort Input Test':67);
END;

PROCEDURE test_input;
BEGIN
  read_file12;
  readln;
  clrscr;
  writeln;
  writeln('Input Test':44);
  writeln;
  delay(200);
  writeln('Close or open an input switch to test':58);
  writeln;
  writeln;
  writeln('Press any key to abort Input Test':56);
  IF (port[portadres + 1] AND 8 = 0) THEN
  BEGIN
    fb:=8
  END
  ELSE
  BEGIN
    fb:=0
  END;
  IF (port[portadres + 1] AND 16 = 0) THEN
  BEGIN
    hs2:=16
  END
  ELSE
  BEGIN
    hs2:=0
  END;
  IF (port[portadres + 1] AND 32 = 0) THEN
  BEGIN
    hs1:=32
  END
  ELSE
  BEGIN
    hs1:=0
  END;
  WHILE NOT keypressed DO
  BEGIN
    IF (port[portadres + 1] AND 16 = hs2) THEN
    BEGIN
      x:=2;
      z:=13;
      which_switch;
      z:=hs2;
    END;
    IF (port[portadres + 1] AND 32 = hs1) THEN
    BEGIN
      z:=12;
      x:=1;
      which_switch;
      z:=hs1
    END;
    IF (port[portadres + 1] AND 8 = fb) THEN
    BEGIN
      clrscr;
      writeln;
      writeln('---------------------------------------':58);
      writeln('Switching detected at input pin 15':53);
      delay(200);
      writeln;
      writeln('This switch must represent FeedBack':55);
      writeln('---------------------------------------':58);
      writeln;
      writeln;
      writeln;
      writeln;
      writeln;
      delay(500);
      writeln('Test another switch or press any key to abort Input Test':67);
    END;
  END;
END;

PROCEDURE jog;
BEGIN
  read_file12;
  readln;
  portadres:= portadres;
  maxspeed:= maxspeed;
  clrscr;
  writeln('Jog Function');
  writeln;
  writeln('Tap "up" arrow key to jog up');
  writeln('Tap "down" arrow key to jog down');
  writeln;
  writeln('Press Esc to exit Jog Function');
  Ch := readKey;
  REPEAT
    ch:=readkey;
    IF (ord(ch) = 72) OR (ord(ch) = 56) THEN
    BEGIN
      c:=0;
      WHILE (c < 15) AND (ord(ch) <> 27) AND ((port[portadres+1] and 32) = 0) do
      BEGIN
        port [portadres]:=2;
        delay(maxspeed);
        port [portadres]:=3;
        c:=c+1;
      END;
    END;
    IF (ord(ch) = 80) OR (ord(ch) = 50) THEN
    BEGIN
      c:=0;
      WHILE (c < 15) AND (ord(ch) <> 27) AND ((port[portadres+1] and 16) = 0) do
      BEGIN
        port [portadres]:=0;
        delay(maxspeed);
        port [portadres]:=1;
        c:=c+1;
      END;
    END
    UNTIL ord(ch) = 27
END;

PROCEDURE task_aborted;
BEGIN
   clrscr;
   writeln;
   writeln('Machine task aborted');
   delay(200);
   writeln('Press Enter');
   readln;
END;

PROCEDURE motor_down;
BEGIN
  port [portadres]:=0;
  delay(cutfeed);
  port [portadres]:=1;
END;

PROCEDURE motor_up;
BEGIN
  port [portadres]:=2;
  delay(maxspeed);
  port [portadres]:=3;
END;

PROCEDURE motor_run;
BEGIN
  motor_down;
  WHILE (port[portadres+1] AND 8) = 8 DO
    BEGIN
      IF (port[portadres+1] AND 32) = 32 THEN
      BEGIN
      exit;
      END;
      BEGIN
        rtrstp:=0;
        motor_up;
        delay(feedpause);
        cnt:=cnt + 1;
        depth1 := (resolution * retractstep * cnt);
        rtrstp1:=retractstep * cnt;
        WHILE NOT (rtrstp >= retractstep) DO
        BEGIN
          clrscr;
          writeline;
          writeln('Retracting ':37,retractstep,' steps');
          motor_up;
          rtrstp:=rtrstp + 1;
        END;
      END;
   END;
END;

PROCEDURE machine_task;
LABEL 1;
BEGIN
  depth1:=0;
  rtrstp1:=0;
  cnt:=0;
  clrscr;
1:WHILE NOT (stepcount >= (stpcnt + rtrstp1)) AND ((port[portadres+1] and 16) = 0) DO
  BEGIN
    depth := resolution * stepcount;
    IF depth1 > 0 THEN
    BEGIN
      depth := depth - depth1;
    END;
    clrscr;
    writeln;
    writeln('Machine task in progress ':48);
    writeln;
    writeln('Electrode depth ':39,depth:0:3,' ',unt);
    writeln;
    writeln('Press any key to pause':46);
    motor_run;
    stepcount:=stepcount + 1;
    IF keypressed AND NOT (stepcount >=(stpcnt + rtrstp1)) THEN
    BEGIN
      clrscr;
      writeln;
      writeln('Machine task paused');
      delay(500);
      writeln('Press Enter');
      readln;
      readln;
      REPEAT
        clrscr;
        writeln;
        writeln('Press "r" then Enter to resume');
        writeln('Press "a" then Enter to abort');
        readln(ans);
      UNTIL (ans = 'r') OR (ans = 'R') OR (ans = 'a') OR (ans = 'A');
      IF ans = 'r' THEN
      GOTO 1
      ELSE
      IF ans = 'a' THEN
      task_aborted;
      exit;
    END
  END
END;

PROCEDURE start_machine_task;
BEGIN
  stepcount:=0;
  motorstep := 360 / angle;
  resolution := pitch / motorstep;
  stpcnt := trunc(cutdepth / resolution);
  machine_task;
  IF stepcount = (stpcnt + rtrstp1) THEN
  BEGIN
    clrscr;
    writeln;
    writeln('Returning to home position');
    WHILE (port[portadres+1] and 32) = 0 DO
    BEGIN
      motor_up;
    END;
    clrscr;
    writeln;
    writeln('Machine task completed');
    writeln('Press Enter');
    readln;
    readln;
  END;
END;

PROCEDURE before_run;
BEGIN
  clrscr;
  writeline;
  writeln('Before starting the Machine Task check the following:');
  writeln;
  writeln('- All connections connected?');
  writeln('- Work piece clamped in?');
  writeln('- Electrode positioned just above work piece?');
  writeln('- Fluid administerd in tank?');
  writeln('- Pump is in operation?');
  writeln('- Driver is on?');
  writeln('- EDM circuit is on?');
  writeln;
  delay(500);
  writeln('Press Enter');
  readln;
  readln;
END;

PROCEDURE start_machine_process;
BEGIN
  before_run;
  read_file12;
  REPEAT
    clrscr;
    writeln;
    writeln('Start Machine Task Menu');
    writeln;
    writeln('Press 1: start machine task');
    writeln('Press 2: to cancel machine task');
    read (sel);
  until (1 <= sel) AND (sel <= 2);
  CASE sel OF
    1:start_machine_task;
    2:task_aborted;
  END;
END;

PROCEDURE select_item (VAR selection:INTEGER);
BEGIN
  REPEAT
  clrscr;
  writeln ('Main Menu');
  REPEAT
    writeln;
    delay (500);
    writeln ('Press 1: Machine Setup');
    writeln ('Press 2: Machine Task Setup');
    writeln ('Press 3: Input Test');
    writeln ('Press 4: Jog');
    writeln ('Press 5: Start Machine Task');
    writeln ('Press 6: Exit');
    writeln;
    writeln ('Press selection then Enter');
    read (selection);
  UNTIL (1 <= selection) AND (selection <= 6);
  CASE selection OF
    1: machine_setup(d,portadres,pitch,angle,maxspeed);
    2: machine_task_setup(e,cutfeed,feedpause,retractstep,cutdepth);
    3: test_input;
    4: jog;
    5: start_machine_process;
    6: exit;
  END
  UNTIL selection = 6;
END;

BEGIN
  enter_program(a);
  select_item(selection);
  readln;
  clrscr;
  writeline;
  writeln('Turn off EDM circuit and short EDM terminals':58);
  writeln;
  write('Press Enter to exit program':48);
  readln;
END.
